package mybox.engine.heliostat;

import mybox.engine.File4Qcad;
import mybox.engine.QVector;
import mybox.engine.servo.StandardServo;

public class Zahnradgelenk extends ZwischenBodenSchachtel {
	
		
	StandardServo servo;
	StandardServo lowerZahnradLoch;
	StandardServo upperZahnradLoch;
	
	
	
	public Zahnradgelenk(File4Qcad file4qcad, QVector aktPos, double materialDicke) {
		
		super(
	    		file4qcad, 
	    		aktPos,
	    		84,//laenge, 
	    		36,//breite, 
	    		45.8+2+3+2*materialDicke,//hoehe, 
	    		28.2-materialDicke,//bodenHoehe, 
	    		materialDicke,
	    		1,//zinkungsFaktor,
		        0.09//laserBreite
		        );
		
		boolean ONLYZAHNRADLOCH=true;
				
		
		QVector servocenterUR= new QVector(	super.grundPlatte1.ecke[1].x-44,
											super.grundPlatte1.ecke[1].y+breite/2);
		
		servo = new StandardServo(file4qcad, servocenterUR, !ONLYZAHNRADLOCH);
		
		QVector lowerZahnradLochPos= new QVector(super.grundPlatte2.ecke[1].x-44,
				super.grundPlatte2.ecke[1].y+breite/2);
		
		lowerZahnradLoch =new StandardServo(file4qcad, lowerZahnradLochPos, ONLYZAHNRADLOCH);
		
		QVector upperZahnradLochPos= new QVector(	super.grundPlatte3.ecke[1].x-44,
				super.grundPlatte3.ecke[1].y+breite/2);
		
		upperZahnradLoch =new StandardServo(file4qcad, upperZahnradLochPos, ONLYZAHNRADLOCH);
		
		
	}

	@Override
	public void draw() {
		super.draw();
		servo.draw();
		lowerZahnradLoch.draw();
		upperZahnradLoch.draw();
	}

}
