package mybox.engine.heliostat;

import mybox.engine.File4Qcad;
import mybox.engine.PlatteOO;
import mybox.engine.QVector;
import mybox.engine.SchachtelOO;

public class ZwischenBodenSchachtel extends SchachtelOO {
	
	
	
	public QVector aktPos;	
	PlatteOO grundPlatte3;

	public ZwischenBodenSchachtel(
			File4Qcad file4qcad, QVector aktPosStart,
			double laenge, double breite, double hoehe, double bodenHoehe, double materialDicke, double zinkungsFaktor,
			double laserBreite) {
			super(file4qcad, aktPosStart, laenge, breite, hoehe, materialDicke, zinkungsFaktor,laserBreite);
						
		String[] typeGrundPlatte = new String[] {"F","F","F","F"};
		
		aktPos = new QVector(aktPosStart);
		grundPlatte1 = new PlatteOO(file4qcad, 
				aktPos,
				typeGrundPlatte,
				laenge,
				breite,			
				materialDicke,
				zinkungsFaktor,
				laserBreite);
		
		aktPos.y-=(hoehe);
		String[] typeLaengenPlatte = new String[] {"M","F","M","F"};
		
		laengenPlatte1=new PlatteOO(file4qcad, 
				aktPos,
				typeLaengenPlatte,
				laenge,
				hoehe,			
				materialDicke,
				zinkungsFaktor,
				laserBreite);
		
		boolean isFemale=false;
		boolean isHorizontal=true;
		double orthoDistance=bodenHoehe;
		boolean noBackset=false;
		
		laengenPlatte1.addLinie(isFemale, isHorizontal, orthoDistance,noBackset);
		
		
		aktPos.x+=laenge+materialDicke; aktPos.y+=hoehe;		
		grundPlatte2 = new PlatteOO(file4qcad, 
				aktPos,
				typeGrundPlatte,
				laenge,
				breite,			
				materialDicke,
				zinkungsFaktor,
				laserBreite);		
		aktPos.y+=breite+materialDicke;
		
		grundPlatte3 = new PlatteOO(file4qcad, 
				aktPos,
				typeGrundPlatte,
				laenge,
				breite,			
				materialDicke,
				zinkungsFaktor,
				laserBreite);
		
		aktPos.y-=breite+hoehe+materialDicke;
		
		laengenPlatte2=new PlatteOO(file4qcad, 
				aktPos,
				typeLaengenPlatte,
				laenge,
				hoehe,			
				materialDicke,
				zinkungsFaktor,
				laserBreite);
				
		laengenPlatte2.addLinie(isFemale, isHorizontal, orthoDistance,noBackset);
		
		String[] typeSeitenPlatte = new String[] {"M","MR","M","MR"};
		aktPos.x+=laenge+materialDicke+3; aktPos.y+=hoehe+2*materialDicke;
		boolean maleBackset=true;
		seitenPlatte1 = new PlatteOO(
				file4qcad, 
				aktPos, 
				typeSeitenPlatte,
				hoehe,breite,materialDicke,zinkungsFaktor,laserBreite);
		seitenPlatte1.addLinie(isFemale, !isHorizontal, orthoDistance, maleBackset);
		aktPos.y-=breite+materialDicke;
		seitenPlatte2 = new PlatteOO(
				        file4qcad, 
				        aktPos, typeSeitenPlatte, 
				        hoehe,breite,materialDicke,zinkungsFaktor,laserBreite);
		seitenPlatte2.addLinie(isFemale, !isHorizontal, orthoDistance, maleBackset);
				
	}
		
	@Override
	public void draw() {
		super.draw();
		grundPlatte3.draw();
	}	
	

}


