package mybox.junit;

import java.io.IOException;

import mybox.engine.DoppelGelenk;
import mybox.engine.File4Qcad;
import mybox.engine.QVector;
import mybox.engine.ReferenceIOutput;
import mybox.engine.heliostat.Heliostat;
import mybox.engine.servo.Servo;


import junit.framework.TestCase;

public class HeliostatTC extends TestCase {
	
public void test_ServoGelenk() throws SecurityException, IOException {
		
		File4Qcad file4qcad = new File4Qcad("/home/hannes/Desktop/output.dxf");		
		QVector aktPos = new QVector (0,0);	
		
		double materialDicke=4;
		double zinkungsFaktor=1;
		double laserBreite=0.04;
		
		
		DoppelGelenk gelenk = new DoppelGelenk(file4qcad, aktPos, materialDicke, zinkungsFaktor, laserBreite, Servo.S3111);
		
		gelenk.draw();
		
		file4qcad.close();
			
	}

public void test_Heliostat() throws SecurityException, IOException {
	
	File4Qcad file4qcad = new File4Qcad(ReferenceIOutput.testoutputFile());		
	QVector aktPos = new QVector (0,0);	
	
	//LaengenMasse in mm, Gewicht in Gramm
	double materialDicke=4;
	double zinkungsFaktor=1;
	double laserBreite=0.04;
	double aufhaengungsLaenge=70;
	
	double spiegelauflageLaenge=30;
	double spiegelauflageBreite=70;
	
	double spiegelGewicht=226; //eine A3 Sperrholzplatte
	double spiegelDicke=4;
	double gegenFreiraum=40;
		
	Heliostat heliostat = new Heliostat(
			file4qcad, 
			aktPos, 
			materialDicke, zinkungsFaktor,laserBreite, 
			Servo.S3111,
			aufhaengungsLaenge,
			spiegelauflageLaenge,
			spiegelauflageBreite,
			spiegelGewicht,
			gegenFreiraum,
			spiegelDicke);
	
	heliostat.draw();
	
	
	
	file4qcad.close();
	
	System.out.println("ggErniedrigung:"+heliostat.gegenGewicht.gegenGewichtErniedrigung);
	System.out.println("tatsFreiraum:"+heliostat.gegenGewicht.tatsFreiraum);
	System.out.println("spiegelErhoehung:"+heliostat.gegenGewicht.spiegelErhoehung);
		
}


}
